﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Microsoft.WindowsAzure.StorageClient;
using Microsoft.WindowsAzure; 

namespace BLOBUrlGenerator
{
    public partial class Form1 : Form
    {

        CloudBlobContainer azureBlobContainer = null;
        CloudStorageAccount azureStorageAcct = null;
        CloudBlobClient azureBlobClient = null;
        BlobContainerPermissions azureBlobPermissions = null;
        CloudBlob azureBlob = null; 
        string submissionDateTime = ""; 

        public Form1()
        {
            InitializeComponent();
            InitializeStorage(); 
        }

        private void InitializeStorage()
        {
            var accountInfo = "DefaultEndpointsProtocol=http;Accountname=fabrikaminc;AccountKey=your acct key here";

            azureStorageAcct = CloudStorageAccount.Parse(accountInfo); 
            
            azureBlobClient = azureStorageAcct.CreateCloudBlobClient();

            azureBlobContainer = azureBlobClient.GetContainerReference("c10testcontainer");
            azureBlobContainer.CreateIfNotExist();
            azureBlob = azureBlobContainer.GetBlobReference("c10testblob");
            azureBlob.UploadText("Test Text");
        }

        private void btnGetURI_Click(object sender, EventArgs e)
        {
            //Set the permissions for the container. 
            SharedAccessPolicy tempAccess = new SharedAccessPolicy();
            tempAccess.SharedAccessStartTime = DateTime.Now;
            tempAccess.SharedAccessExpiryTime = DateTime.Now.AddHours(48);
            tempAccess.Permissions = SharedAccessPermissions.Read;

            BlobContainerPermissions tempPermissions = new BlobContainerPermissions();
            tempPermissions.SharedAccessPolicies.Clear();
            tempPermissions.SharedAccessPolicies.Add("John Doe", tempAccess);
            azureBlobContainer.SetPermissions(tempPermissions);

            string sharedAccessSig = azureBlobContainer.GetSharedAccessSignature(tempAccess);
            string sharedAccessURI = azureBlobContainer.Uri.AbsoluteUri + sharedAccessSig;

            txtbxURI.Text = sharedAccessURI; 
        }

        private void btnExit_Click(object sender, EventArgs e)
        {
            Application.Exit(); 
        }
    }
}
