﻿using System;
using System.Collections.Generic;
using System.Runtime.Serialization;
using System.ServiceModel;
using System.ServiceModel.Web;
using System.Text;
using System.Net;
using System.IO;
using System.Xml.Linq;
using System.Linq;

namespace GetDallasData
{
    public class DallasCrimeData : IDallasCrimeData
    {
        string myAccountKey = "<your account key here>";
        string myUniqueUserId = "<your user id here>";
        string myDallasURL = "https://api.datamarket.azure.com/Data.ashx/data.gov/Crimes/CityCrime?$filter=State%20eq%20%27Washington%27&$top=100";

        public List<CrimeData> GetCrimeData(string stateFilter)
        {
            List<CrimeData> listOfCrimesInWashington = new List<CrimeData>();

            WebRequest azureWebRequest = WebRequest.Create(myDallasURL);
            azureWebRequest.Credentials = new NetworkCredential(myAccountKey, myUniqueUserId);

            using (HttpWebResponse azureWebResponse = (HttpWebResponse)azureWebRequest.GetResponse())
            {
                using (Stream AzureDataStream = azureWebResponse.GetResponseStream())
                {
                    using (StreamReader reader = new StreamReader(AzureDataStream))
                    {
                        string responseFromAzure = reader.ReadToEnd();
                        XDocument xmlAzureResultData = XDocument.Parse(responseFromAzure);

                        XNamespace nsContent = "http://www.w3.org/2005/Atom";
                        XNamespace nsProperties = "http://schemas.microsoft.com/ado/2007/08/dataservices/metadata";
                        XNamespace nsValue = "http://schemas.microsoft.com/ado/2007/08/dataservices";

                        var result = (from q in xmlAzureResultData.Descendants(nsContent + "entry")
                                      select new CrimeData
                                      {
                                          City = q.Element(nsContent + "content").Element(nsProperties + "properties").Element(nsValue + "City").Value.ToString(),
                                          Year = q.Element(nsContent + "content").Element(nsProperties + "properties").Element(nsValue + "Year").Value.ToString(),
                                          Population = q.Element(nsContent + "content").Element(nsProperties + "properties").Element(nsValue + "Population").Value.ToString(),
                                          ViolentCrime = q.Element(nsContent + "content").Element(nsProperties + "properties").Element(nsValue + "ViolentCrime").Value.ToString(),
                                          Robbery = q.Element(nsContent + "content").Element(nsProperties + "properties").Element(nsValue + "Robbery").Value.ToString(),
                                          PropertyCrime = q.Element(nsContent + "content").Element(nsProperties + "properties").Element(nsValue + "PropertyCrime").Value.ToString(),
                                          Burglary = q.Element(nsContent + "content").Element(nsProperties + "properties").Element(nsValue + "Burglary").Value.ToString()
                                      });

                        foreach (var c in result)
                        {
                            listOfCrimesInWashington.Add(c);
                        }
                    }
                }
            }
            return listOfCrimesInWashington;
        }
    }
}
