﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.SharePoint;

namespace AzureConsoleApp
{
    class Program
    {
        static void Main(string[] args)
        {
            string mortgageOffering = "Test";
            string mortgageRate = "Test 2";
            string mortgageAPR = "Test 3";

            string mySPSite = "http://blueyonderdemo";

            using (SPSite site = new SPSite(mySPSite))
            {
                using (SPWeb web = site.OpenWeb())
                {
                    web.AllowUnsafeUpdates = true;

                    SPList mortgageList = web.GetList("Lists/MortgagesList");

                    SPQuery myCAMLQuery = new SPQuery(); 

                    myCAMLQuery.Query =    "<Query>" +
                                            "<Where><Eq>" +
                                                "<FieldRef Name='Title'></FieldRef>" +
                                                    "<Value Type='Text'>Contoso</Value>" +
                                            "</Eq></Where></Query>";

                    SPListItemCollection collItem = mortgageList.GetItems(myCAMLQuery);

                    foreach (SPListItem oItem in collItem)
                    {

                        if (oItem["Title"].ToString() == "Contoso")
                        {
                            oItem["Offering"] = mortgageOffering;
                            oItem["Rate"] = mortgageRate;
                            oItem["APR"] = mortgageAPR;
                            oItem.Update(); 
                        }

                    }

                    web.AllowUnsafeUpdates = false;

                }
                Console.WriteLine("Hit any key to exit application"); 
                Console.ReadLine();
            }
        }

        class StoreInfo
        {
            public string storeAddress { get; set; }
            public string storePhone { get; set; }
        }

    }
}
