﻿using System;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Data.SqlClient;
using System.Data;
using Microsoft.SharePoint;
using System.Collections.Generic;
using System.Linq; 

namespace SchedulingWebPart.ScheduleWebPart
{
    public partial class ScheduleWebPartUserControl : UserControl
    {
        CustomersEntities dc = new CustomersEntities(); 

        string queryString = "SELECT * from Customers.dbo.StoreInformation;";
        DataSet azureDataset = new DataSet();

        string mySPSite = "http://blueyonderdemo";

        protected void Page_Load(object sender, EventArgs e)
        {
            populateDropDownBox();
        }

        private void populateDropDownBox()
        {
            string storeName = "";

            string connectionString = "Server=tcp:<server name>;Database=Customers;User ID=<your id>;Password=<your password>;Trusted_Connection=False;Encrypt=True;";

            using (SqlConnection connection = new SqlConnection(connectionString))
            {
                SqlDataAdapter adaptor = new SqlDataAdapter();
                adaptor.SelectCommand = new SqlCommand(queryString, connection);
                adaptor.Fill(azureDataset);

                foreach (DataRow custRecord in azureDataset.Tables[0].Rows)
                {
                    storeName = custRecord[2].ToString();
                    drpdwnlstStores.Items.Add(storeName); 
                }
            }
        }

        protected void btnSubmit_Click(object sender, EventArgs e)
        {
            string storeNameFromList = drpdwnlstStores.SelectedItem.ToString();
            string meetingLocation = drpdwnStoreLocation.SelectedItem.ToString();
            string meetingDate = clndrControl.SelectedDate.ToShortDateString();
            string meetingTime = drpdwnMeetingTime.SelectedItem.ToString();
            double meetingTimeHours = 0;

            if (meetingTime == "Breakfast Meeting")
            {
                meetingTimeHours = 8; 
            }
            else if (meetingTime == "Lunch Meeting")
            {
                meetingTimeHours = 12;
            }
            else if (meetingTime == "Dinner Meeting")
            {
                meetingTimeHours = 17; 
            }

            if (chkbxAddAnnouncement.Checked == true)
            {
                createAnEvent(storeNameFromList, meetingLocation, meetingDate, meetingTimeHours);
                createAnAnnouncement(storeNameFromList, meetingLocation, meetingDate);
                lblMessageToUser.Text = "A new event and an announcement have been created for this meeting."; 
            }
            else
            {
                createAnEvent(storeNameFromList, meetingLocation, meetingDate, meetingTimeHours);
                lblMessageToUser.Text = "A new event has been created for this meeting.";
            }
        }

        private void createAnAnnouncement(string storeNameFromList, string meetingLocation, string meetingDate)
        {
            string finalStoreLocation = "";

            var query = from store in dc.StoreInformations
                        where store.StoreName== storeNameFromList
                        select store;

            foreach (var item in query)
            {
                finalStoreLocation = item.StoreAddress;
            }

            using (SPSite site = new SPSite(mySPSite))
            {
                using (SPWeb web = site.OpenWeb())
                {
                    web.AllowUnsafeUpdates = true;

                    SPList list = web.Lists["Announcements"];
                    SPListItem item = list.Items.Add();
                    item["Title"] = storeNameFromList + " Meeting";
                    item["Body"] = storeNameFromList + " Meeting";
                    item["Store Address"] = meetingLocation + ": " + finalStoreLocation;
                    item["Meeting Date"] = meetingDate;
                    item.Update();

                    web.AllowUnsafeUpdates = false;
                }
            }
        }

        private void createAnEvent(string storeNameFromList, string meetingLocation, string meetingDate, double meetingTimeHours)
        {
            string finalStoreLocation = "";

            DateTime startOfMeeting = DateTime.Parse(meetingDate).AddHours(meetingTimeHours);
            DateTime endOfMeeting = startOfMeeting.AddHours(2); 

            var query = from store in dc.StoreInformations
                        where store.StoreName == storeNameFromList
                        select store;

            foreach (var item in query)
            {
                finalStoreLocation = item.StoreAddress;
            }

            using (SPSite site = new SPSite(mySPSite))
            {
                using (SPWeb web = site.OpenWeb())
                {
                    web.AllowUnsafeUpdates = true;

                    SPList list = web.Lists["Calendar"];
                    SPListItem item = list.Items.Add();
                    item["Title"] = storeNameFromList + " Meeting";
                    item["Location"] = finalStoreLocation;
                    item["Description"] = storeNameFromList + " Meeting";
                    item["Start Time"] = startOfMeeting;
                    item["End Time"] = endOfMeeting;
                    item.Update();

                    web.AllowUnsafeUpdates = false;
                }
            }
             
        }
    }
}






