﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.ServiceModel;
using System.ServiceModel.Web;
using System.Text;
using System.Net;
using System.IO;
using System.Xml.Linq;
using System.Globalization;

namespace GetAzureCloudStorageData
{  
    public class GetAzureStorageData : IGetAzureStorageData
    {
        public string GetData()
        {
            string returnData = ""; 

            HttpWebRequest hwr = RequestData(new Uri(@"http://youraccountnamehere.blob.core.windows.net/imagefiles?restype=container&comp=list"),
                "GET", new TimeSpan(0, 0, 30));

            using (StreamReader sr = new StreamReader(hwr.GetResponse().GetResponseStream()))
            {
                XDocument myDocument = XDocument.Parse(sr.ReadToEnd());
                returnData = myDocument.ToString(); 
            }

            return returnData; 
        }

        private static HttpWebRequest RequestData(Uri uri, string httpMethod, TimeSpan timeOut)
        {
            HttpWebRequest request = (HttpWebRequest)HttpWebRequest.Create(uri);
            request.Timeout = (int)timeOut.TotalMilliseconds;
            request.ReadWriteTimeout = (int)timeOut.TotalMilliseconds;
            request.Method = httpMethod;
            request.ContentLength = 0;
            request.Headers.Add("x-ms-date",
                DateTime.UtcNow.ToString("R", CultureInfo.InvariantCulture));
            request.Headers.Add("x-ms-version", "2009-09-19");
            return request;
        }

    }
}
