﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Xml;
using System.Xml.Linq; 
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using SLMortgageApplication.AzureMortgageService; 

namespace SLMortgageApplication
{
    public partial class MainPage : UserControl
    {
        //double[] returnMortgageData = new double[6];
        double mortgateAPR = .18;
        double[] pastMortgageRates = new double[6];

        List<MortgageDetails> listOfMortgageData = new List<MortgageDetails>();
        List<Double> returnDblData = new List<Double>();

        string strTrend = "";
        string[] strResults = new string[6];  

        public MainPage()
        {
            InitializeComponent();
        }

        private void btnGetData_Click(object sender, RoutedEventArgs e)
        {
            pastMortgageRates[0] = .39;
            pastMortgageRates[1] = .58;
            pastMortgageRates[2] = .44;
            pastMortgageRates[3] = .34;
            pastMortgageRates[4] = .62;
            pastMortgageRates[5] = 1.22;

            Service1Client myProxy = new Service1Client();
            myProxy.getDailyInterestRateAsync(); 
            myProxy.getDailyInterestRateCompleted += new EventHandler<getDailyInterestRateCompletedEventArgs>(myProxy_getDailyInterestRateCompleted);
        }

        void myProxy_getDailyInterestRateCompleted(object sender, getDailyInterestRateCompletedEventArgs e)
        {
            var query = from mort in e.Result
                        select mort;

            int i = 0;
            foreach (var item in e.Result)
            {
                returnDblData.Add(query.ElementAt(i));
                strResults[i] = returnDblData.ElementAt(i).ToString(); 
                i++; 
            }

            int j = 0;
            foreach (var item in returnDblData)
            {
                MortgageDetails tempObj = new MortgageDetails();

                if (j == 0)
                {
                    tempObj.Offering = "30 YR Fixed"; 
                }
                else if (j == 1)
                {
                    tempObj.Offering = "15 YR Fixed";
                }
                else if (j == 2)
                {
                    tempObj.Offering = "3 YR ARM";
                }
                else if (j == 3)
                {
                    tempObj.Offering = "5 YR ARM";
                }
                else if (j == 4)
                {
                    tempObj.Offering = "7 YR ARM";
                }
                else if (j == 5)
                {
                    tempObj.Offering = "10 YR ARM";
                }

                tempObj.Rate = strResults[j];
                tempObj.APR = (double.Parse(strResults[j]) + mortgateAPR).ToString(); 
                tempObj.Change = (double.Parse(strResults[j]) - pastMortgageRates[j]).ToString(); 
                tempObj.Trend = calculateTrend(double.Parse(strResults[j]), pastMortgageRates[j]);

                listOfMortgageData.Add(tempObj);
                j++; 
            }

            datagrdAzureMortgageData.ItemsSource = listOfMortgageData; 
        }

        private string calculateTrend(double currentMortgageRate, double pastMortgageRate)
        {
            double mortgageTrend = 0.00;

            mortgageTrend = currentMortgageRate - pastMortgageRate;

            if (mortgageTrend > 0.00)
            {
                strTrend = "+";
            }
            else if (mortgageTrend < 0.00)
            {
                strTrend = "-";
            }
            else if (mortgageTrend == 0.00)
            {
                strTrend = "NC";
            }

            return strTrend;
        }

    }
}
